#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 Red

//
//
//
//
//

extern string TimeFrame = "Current time frame";
extern int    CmfPeriod = 21;

//
//
//
//
//

double Cmf[];

//
//
//
//
//

string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;


//+------------------------------------------------------------------+  
//|                                                                  | 
//+------------------------------------------------------------------+ 
//
//
//
//
//
 
int init()
{
   SetIndexBuffer(0,Cmf);
   
      //
      //
      //
      //
      //
      
         indicatorFileName = WindowExpertName();
         calculateValue    = TimeFrame=="calculateValue"; if (calculateValue) { return(0); }
         returnBars        = TimeFrame=="returnBars";     if (returnBars)     { return(0); }
         timeFrame         = stringToTimeFrame(TimeFrame);
      
      //
      //
      //
      //
      //
               
   IndicatorShortName(timeFrameToString(timeFrame)+" Cmf correct formula ("+CmfPeriod+")");
   return(0);
}

//+------------------------------------------------------------------+  
//|                                                                  | 
//+------------------------------------------------------------------+ 
//
//
//
//
//
 
int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { Cmf[0] = MathMin(limit+1,Bars-1); return(0); }

   //
   //
   //
   //
   //

   if (calculateValue || timeFrame == Period())
   {
     for(i=limit; i>=0; i--)
     {
        double sumVol = 0;
        double sumAcd = 0;
        for (int k=0; k<CmfPeriod && (i+k)<Bars; k++)
           {
              double range = High[i+k]-Low[i+k];
              if (range != 0)
                  double change = Volume[i+k]*((Close[i+k]-Low[i+k])-(High[i+k]-Close[i+k]))/range;
              else       change = 0;
              sumVol += Volume[i+k];
              sumAcd += change;
           }

           //
           //
           //
           //
           //
        
           Cmf[i] = sumAcd/sumVol;
     }
     return(0);
   }
  
   //
   //
   //
   //
   //

   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         Cmf[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",CmfPeriod,0,y);
   }
return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}